<?php
/**
*
* @package mChat ACP Core
* @version 1.0.1 of 07.02.2011
* @copyright (c) By Shapoval Andrey Vladimirovich (AllCity) ~ http://allcity.net.ru/
* @copyright Gemini_13 < Gemini_13@gala.net >
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
**/

/**
* DO NOT CHANGE!
* http://wiki.phpbb.com/display/DEV/Using+the+phpBB3.0+Module+System
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_mchat
{
	var $u_action;
	var $new_config = array();

	function main($id, $mode)
	{
		global $config, $user, $cache, $template;

		$action = request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		$form_key = 'acp_mchat';
		add_form_key($form_key);

		// Options (global)
		$config['mchat_enable'] = (isset($config['mchat_enable'])) ? $config['mchat_enable'] : true;
		$config['mchat_refresh_time'] = (isset($config['mchat_refresh_time'])) ? $config['mchat_refresh_time'] : 10;
		$config['mchat_message_limit'] = (isset($config['mchat_message_limit'])) ? $config['mchat_message_limit'] : 10;
		$config['mchat_archive_limit'] = (isset($config['mchat_archive_limit'])) ? $config['mchat_archive_limit'] : 20;
		$config['mchat_flood_time'] = (isset($config['mchat_flood_time'])) ? $config['mchat_flood_time'] : 60;
		$config['mchat_allow_urls'] = (isset($config['mchat_allow_urls'])) ? $config['mchat_allow_urls'] : true;
		$config['mchat_allow_smilies'] = (isset($config['mchat_allow_smilies'])) ? $config['mchat_allow_smilies'] : true;
		$config['mchat_color_nick'] = (isset($config['mchat_color_nick'])) ? $config['mchat_color_nick'] : false;
		$config['mchat_message_max_length'] = (isset($config['mchat_message_max_length'])) ? $config['mchat_message_max_length'] : 500;
		$config['mchat_not_allowed_bbcodes'] = (isset($config['mchat_not_allowed_bbcodes'])) ? $config['mchat_not_allowed_bbcodes'] : '';
		$config['mchat_use_custom_page'] = (isset($config['mchat_use_custom_page'])) ? $config['mchat_use_custom_page'] : true;
		$config['mchat_use_custom_page_whois'] = (isset($config['mchat_use_custom_page_whois'])) ? $config['mchat_use_custom_page_whois'] : true;
		$config['mchat_date_format'] = (isset($config['mchat_date_format'])) ? $config['mchat_date_format'] : 'd M Y, H:i';
		$config['mchat_message_max_word'] = (isset($config['mchat_message_max_word'])) ? $config['mchat_message_max_word'] : 100;

		// Options (admin)
		$config['mchat_allow_admin_edit'] = (isset($config['mchat_allow_admin_edit'])) ? $config['mchat_allow_admin_edit'] : true;
		$config['mchat_allow_admin_del'] = (isset($config['mchat_allow_admin_del'])) ? $config['mchat_allow_admin_del'] : true;
		$config['mchat_allow_admin_ip'] = (isset($config['mchat_allow_admin_ip'])) ? $config['mchat_allow_admin_ip'] : true;
		$config['mchat_allow_admin_bbcode'] = (isset($config['mchat_allow_admin_bbcode'])) ? $config['mchat_allow_admin_bbcode'] : true;
		$config['mchat_admin_no_flood'] = (isset($config['mchat_admin_no_flood'])) ? $config['mchat_admin_no_flood'] : true;

		// Options (moder)
		$config['mchat_allow_moder_edit'] = (isset($config['mchat_allow_moder_edit'])) ? $config['mchat_allow_moder_edit'] : true;
		$config['mchat_allow_moder_del'] = (isset($config['mchat_allow_moder_del'])) ? $config['mchat_allow_moder_del'] : true;
		$config['mchat_allow_moder_ip'] = (isset($config['mchat_allow_moder_ip'])) ? $config['mchat_allow_moder_ip'] : true;
		$config['mchat_allow_moder_bbcode'] = (isset($config['mchat_allow_moder_bbcode'])) ? $config['mchat_allow_moder_bbcode'] : true;
		$config['mchat_moder_no_flood'] = (isset($config['mchat_moder_no_flood'])) ? $config['mchat_moder_no_flood'] : true;

		// Options (user)
		$config['mchat_allow_user_bbcode'] = (isset($config['mchat_allow_user_bbcode'])) ? $config['mchat_allow_user_bbcode'] : true;
		$config['mchat_allow_user_add_mess'] = (isset($config['mchat_allow_user_add_mess'])) ? $config['mchat_allow_user_add_mess'] : true;
		$config['mchat_allow_user_read_archive'] = (isset($config['mchat_allow_user_read_archive'])) ? $config['mchat_allow_user_read_archive'] : true;

		// Options (guest)
		$config['mchat_allow_guest_bbcode'] = (isset($config['mchat_allow_guest_bbcode'])) ? $config['mchat_allow_guest_bbcode'] : false;
		$config['mchat_allow_guest_add_mess'] = (isset($config['mchat_allow_guest_add_mess'])) ? $config['mchat_allow_guest_add_mess'] : true;
		$config['mchat_allow_guest_read_archive'] = (isset($config['mchat_allow_guest_read_archive'])) ? $config['mchat_allow_guest_read_archive'] : false;
		
		$display_vars = array(
			'title' => 'ACP_MCHAT',
			//'lang' => 'mods/info_acp_mchat_lang',
			'vars' => array(
				// Options (global)
				'legend1' => 'ACP_MCHAT_LEGEND1',
				'mchat_enable' => array('lang' => 'ACP_MCHAT_ENABLE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => true ),
				'mchat_refresh_time' => array('lang' => 'ACP_MCHAT_REFRESH_TIME', 'validate' => 'int:5', 'type' => 'text:3:4', 'explain' => false),
				'mchat_message_limit' => array('lang' => 'ACP_MCHAT_MESSAGE_LIMIT', 'validate' => 'int:5', 'type' => 'text:3:4', 'explain' => true ),
				'mchat_archive_limit' => array('lang' => 'ACP_MCHAT_ARCHIVE_LIMIT', 'validate' => 'int:5', 'type' => 'text:3:4', 'explain' => true ),
				'mchat_flood_time' => array('lang' => 'ACP_MCHAT_FLOOD_TIME', 'validate' => 'int:0', 'type' => 'text:3:4', 'explain' => true ),
				'mchat_allow_urls' => array('lang' => 'ACP_MCHAT_ALLOW_URLS', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_smilies' => array('lang' => 'ACP_MCHAT_ALLOW_SMILIES', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_color_nick' => array('lang' => 'ACP_MCHAT_COLOR_NICK', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_message_max_length' => array('lang' => 'ACP_MCHAT_MESSAGE_MAX_LENGTH', 'validate' => 'int:0', 'type' => 'text:3:4', 'explain' => true ),
				'mchat_not_allowed_bbcodes' => array('lang' => 'ACP_MCHAT_NOT_ALLOWED_BBCODES', 'validate' => 'string', 'type' => 'text:0:255', 'explain' => true ),
				'mchat_use_custom_page' => array('lang' => 'ACP_MCHAT_USE_CUSTOM_PAGE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_use_custom_page_whois' => array('lang' => 'ACP_MCHAT_USE_CUSTOM_PAGE_WHOIS', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => true ),
				'mchat_date_format' => array('lang' => 'ACP_MCHAT_DATE_FORMAT', 'validate' => 'string', 'type' => 'text:0:255', 'explain' => true ),
				'mchat_message_max_word' => array('lang' => 'ACP_MCHAT_MESSAGE_MAX_WORD', 'validate' => 'int:0', 'type' => 'text:3:4', 'explain' => true ),

				// Options (admin)
				'legend2' => 'ACP_MCHAT_LEGEND2',
				'mchat_allow_admin_edit' => array('lang' => 'ACP_MCHAT_ALLOW_ADMIN_EDIT', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_admin_del' => array('lang' => 'ACP_MCHAT_ALLOW_ADMIN_DEL', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_admin_ip' => array('lang' => 'ACP_MCHAT_ALLOW_ADMIN_IP', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_admin_bbcode' => array('lang' => 'ACP_MCHAT_ALLOW_ADMIN_BBCODE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_admin_no_flood' => array('lang' => 'ACP_MCHAT_ADMIN_NO_FLOOD', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),

				// Options (moder)
				'legend3' => 'ACP_MCHAT_LEGEND3',
				'mchat_allow_moder_edit' => array('lang' => 'ACP_MCHAT_ALLOW_MODER_EDIT', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_moder_del' => array('lang' => 'ACP_MCHAT_ALLOW_MODER_DEL', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_moder_ip' => array('lang' => 'ACP_MCHAT_ALLOW_MODER_IP', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_moder_bbcode' => array('lang' => 'ACP_MCHAT_ALLOW_MODER_BBCODE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_moder_no_flood' => array('lang' => 'ACP_MCHAT_MODER_NO_FLOOD', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),

				// Options (user)
				'legend4' => 'ACP_MCHAT_LEGEND4',
				'mchat_allow_user_bbcode' => array('lang' => 'ACP_MCHAT_ALLOW_USER_BBCODE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_user_add_mess' => array('lang' => 'ACP_MCHAT_ALLOW_USER_ADD_MESS', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_user_read_archive' => array('lang' => 'ACP_MCHAT_ALLOW_USER_READ_ARCHIVE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_user_no_flood' => array('lang' => 'ACP_MCHAT_USER_NO_FLOOD', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),

				// Options (guest)
				'legend5' => 'ACP_MCHAT_LEGEND5',
				'mchat_allow_guest_bbcode' => array('lang' => 'ACP_MCHAT_ALLOW_GUEST_BBCODE', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_guest_add_mess' => array('lang'  => 'ACP_MCHAT_ALLOW_GUEST_ADD_MESS', 'validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),
				'mchat_allow_guest_read_archive' => array('lang' => 'ACP_MCHAT_ALLOW_GUEST_READ_ARCHIVE','validate' => 'bool', 'type' => 'radio:enabled_disabled', 'explain' => false),

				// Seve - Reset
				'legend6' => 'CONFIRM',
			)
		);

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		if ($submit && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}

		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}

		// Grab global variables, re-cache if necessary
		if ($submit)
		{
			$config = $cache->obtain_config();
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

			if ($submit)
			{
				set_config($config_name, $config_value);
			}
		}

		if ($submit)
		{
			add_log('admin', 'LOG_CONFIG_' . strtoupper($mode));

			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$this->tpl_name = 'acp_board';
		$this->page_title = $display_vars['title'];

		$template->assign_vars(array(
			'L_TITLE' => $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN' => $user->lang[$display_vars['title'] . '_EXPLAIN'] ,

			'S_ERROR' => (sizeof($error)) ? true : false,
			'ERROR_MSG' => implode('<br />', $error),

			'U_ACTION' => $this->u_action)
		);

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND' => true,
					'LEGEND' => (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$template->assign_block_vars('options', array(
				'KEY' => $config_key,
				'TITLE' => (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN' => $vars['explain'],
				'TITLE_EXPLAIN' => $l_explain,
				'CONTENT' => build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
				)
			);
		
			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>